#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "krandom.h"
#include "qlearn.h"
#include "defs.h"

int actionCount = 3;

void testQlearning(Qlearn &);

main(int , char *argv[])
{

  // initialize the random number generator
  int rinit = -time(NULL)%100; 
  int rseed = -1000 + rinit*rinit*rinit; 

  // set up a large negative number as random seed; 
  initialize_random_number_generator(rseed); 

  Qlearn qlearn;

  testQlearning(qlearn);
  return 1;
}

double
collectReward(int state) 
{
  if (state == 0) return 1;
  else return 0;
}


void
testQlearning(Qlearn &qlearn)
{
  int stepCount = 0;
  while (1) {
    // if this trial is too long, start a new one 
    if (stepCount == 1000) { stepCount = 0; qlearn.resetState(); }
    // if the bird reached the goal, start a new trial
    // mind you this is done only for testing, in the 
    // real application we have to make the bird wonder
    // of after the food supply ends
    if (qlearn.getState() == 0) { qlearn.resetState(); }
    // most of the time pick the best action there is
    if (stepCount % 3 != 0) {
      Action bestAction = qlearn.chooseBestAction();
      qlearn.performAction(bestAction);
    }
    // but sometimes pick a random action
    else {
      Action randomAction = (Action) choose_random_int_value(actionCount - 1);
      qlearn.performAction(randomAction);
    }
    stepCount++;
  }
}
