#include "defs.h"

#ifndef Q_LEARN_H
#define Q_LEARN_H

class Qlearn {

public:

  ~Qlearn();
  Qlearn();

  inline int             getState(void) { return currentState; }

  void                   resetState(void);
  void                   performAction(Action);
  Action                 chooseBestAction(void);

private:

  int                    minState;
  int                    maxState;
  int                    stateCount; 
  int                    currentState;

  double                 learningRate;
  double                 discountFactor;
  double **              qvalues;

  int                    evaluateAction(Action);
  double                 findMaxExpectation(int);
};
	
#endif
